(define (fonema_speak_manuscript tgt_dir src_fn)
"(fonema_speak_manuscript tgt_dir src_fn)
Synthesize and store multiple sentences from a given manuscript
"
(let ((p (load src_fn t)))
  (mapcar
   (lambda (l)
     (let ((u (fonema_makeutt (cadr l))))
     ; Funksjonene under opererer p en ytring, u.
     ; Du kan legge til, ta bort eller endre 
     (print (cadr l))
     (utt.relation.print u "Word")
     ; lager blgeform. bauck: nsker denne outputen til fil!
     (unwind-protect
       (Wave_Synth u)
       (begin
         (format t (string-append "Error in " (car l) "\n"))))
     (unwind-protect
       (utt.save.relation u "Unit" (string-append tgt_dir "/unit_" (car l) ".txt"))
       (begin
         (format t (string-append "Error in " (car l) "\n"))
         (utt.save.words u (string-append tgt_dir "/error_unit_" (car l) ".txt"))))
     ; spiller av lyd. bauck: ikke ndvendig n!
     ;(utt.play u)
     ; lagrer lyd som "<tgt_dir>/fnm_<ID>.wav"
     (unwind-protect
       (utt.save.wave u (string-append tgt_dir "/" (car l) ".wav"))
       (begin
         (format t (string-append "Error in " (car l) "\n"))))
     )
    t)
   p)
  t)
)

(define (fonema_say_manuscript src_fn)
"(fonema_say_manuscript src_fn)
Synthesize and speaks multiple sentences from a given manuscript
"
(let ((p (load src_fn t)))
  (mapcar
   (lambda (l)
     (let ((u (fonema_makeutt (cadr l))))
     ; Funksjonene under opererer p en ytring, u.
     ; Du kan legge til, ta bort eller endre 
     (print (cadr l))
     (utt.relation.print u "Word")
     (Wave_Synth u) ; lager blgeform
     (utt.play u) ; spiller av lyden
     )
    t)
   p)
  t)
)

(provide 'fonema_manuscript) ;; BYTT UT <NAVN> med det navnet du har valgt, f.eks. mitt_skript