# -*- coding: cp1252 -*-
import string, sys
from os import path
from os.path import dirname, join
from est import *
from est.item import *
from fonema.tts.make_utts import *
from fonema.teksfon import Teksfon, sent2utt
from fonema import teksfon

# Define which text-to-diphone rules should be used
lexdir = "/usr/local/src/FonemaCVS/Lexica/teksfon/data"
teksfon.user_lex = path.join(lexdir,"lu.crp")
teksfon.main_lex = path.join(lexdir,"lm.crp")
teksfon.name_lex = path.join(lexdir,"ln.crp")
teksfon.pron_rls = path.join(lexdir,"pr.crp")

utt_score = [0, 0, 0, 0, 0] # [uendret, /sil/, substitusjon, fjerning, ingen triks]

def synthezise(sentence, utt_id):
    t = Teksfon()
    s = t.proc_string(sentence)
    u = sent2utt(s)
    u_orig = sent2utt(s)
    
    u2 = EST_Utterance()
    
    # Loading file with all the voice's diphones and put into a list
    diphone_file = open('diphones_voice_1.txt', 'r')
    diphones_list = []
    for line in diphone_file.readlines():
        diphones_list.append(str(line)[:-2])
    
    relations = ["Word", "Syllable", "Target", "Foot", "Intonation", "IntEvent", "SylStructure", "Phrase"]
    
    # Moving all other relations than Segment from u to u2
    for rel in relations:
        u2_rel = u2.create_relation(rel)
        for item in u[rel]:
            u2_rel.append(item)
    
    # Creating some objects to use under utt manipulation
    previous = None
    item_orig = None
    word_orig = None
    previous_orig = None
    append_next = True

    silence = False
    remove = False
    substitution = False
    unable = False

    sil_score = 0
    sub_score = 0
    remove_score = 0
    unable_score = 0
    
    # Time to look at the diphones...
    u2_seg = u2.create_relation("Segment")
    for item in u["Segment"]:
    
        if item_orig != None:
            item_orig = next(item_orig)
            word_orig = parent(parent(item_orig, "SylStructure"), "SylStructure")
            print get_name(item_orig), get_feature(word_orig, "name"),
        else:
            item_orig = u_orig["Segment"].head()
            word_orig = parent(parent(item_orig, "SylStructure"), "SylStructure")
            print get_name(item_orig), get_feature(word_orig, "name"),
    
        diph = str(get_feature(item, "name")) + '_' + str(get_feature(previous, "name"))
        print diph,
    
        if diph not in diphones_list and diph != 'sil_0':
            # sil_0 is a "dummy" phonem at the start of all sentences
            # sil_0 is not included in the speech synthesis

            if diph == "sil_sil": append_next = False
    
            if str(get_feature(word_orig, "name")) != str(get_feature(parent(parent(previous_orig, "SylStructure"), "SylStructure"), "name")) and'sil_'+str(get_feature(previous, "name")) in diphones_list and str(get_feature(item, "name"))+'_sil' in diphones_list:
                sil = EST_Item()
                sil["name"] = 'sil'
                sil_end = item["end"]
                sil_parent = parent(item, "SylStructure")
                item["end"] = float(str(float(sil_end) - 0.01)[:5])
                sil["end"] = sil_end
                previous = u2_seg.append(sil)
                append_daughter(sil_parent, "SylStructure", sil)
                silence = True
            elif diph == 'rL__ae': previous["name"] = 'ae:'
    
            # As in Jackson. Sounds a bit weird
            elif diph == 'ae_Z_': item["name"] = 'e'
    
            elif diph == 'i_Z_': # As in Beijing. MAJOR HACK !!
                i_diph = EST_Item()
                i_diph["name"] = 'i:'
                i_diph_end = item["end"]
                i_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(i_diph_end) - 0.01)[:5])
                i_diph["end"] = i_diph_end
                previous = u2_seg.append(i_diph)
                append_daughter(i_diph_parent, "SylStructure", i_diph)
    
                if word_orig["name"] == 'Beijing':
                    # Har igjen /i Ng/, nsker /i Ng g/
                    # Legger til nytt fonem /i/
                    print 'Trouble',
                    i__diph = EST_Item()
                    i__diph["name"] = 'i'
                    i__diph_end = item["end"]
                    i__diph_parent = parent(item, "SylStructure")
                    previous["end"] = float(str(float(i__diph_end) - 0.01)[:5])
                    i__diph["end"] = i__diph_end
                    previous = u2_seg.append(i__diph)
                    append_daughter(i_diph_parent, "SylStructure", i_diph)
    
                    # Endrer navn i resterende difoner, fra /i Ng/ til /Ng g/
                    item["name"] = 'Ng'
                    item_next = next(item)
                    item_next["name"] = 'g'
    
            elif diph == 'Ai_n': item["name"] = 'aei'
            elif diph == 'eh_Ch': item["name"] = 'e'
            elif diph == 'ou_e': previous["name"] = 'eh'
            elif diph == 'j_rl': previous["name"] = 'rL_'
            elif diph == 'b_rl': previous["name"] = 'rL_'
            elif diph == 'h_rL_': previous["name"] = 'l'
            elif diph == 'Sh_rl': item["name"] = 's'
            elif diph == 'A:_Oy': previous["name"] = 'ou'
            elif diph == 'Ng_oe': item["name"] = 'n'
            elif diph == 'e:_e' or diph == 'eh_eh': item["name"] = 'e'
            elif diph == 'O_oey': item["name"] = 'O:'
            elif diph == 'ou_Ch': item["name"] = 'ou:'
            elif diph == 'u:_y': item["name"] = 'O:'
            elif diph == 'm_h' and str(get_feature(word_orig, "name")) == 'Ahmed': previous["name"] = 'k'
            elif diph == 'oe_ou' and str(get_feature(word_orig, "name")) == 'forfulgt':
                previous["name"] = 'f'
                item["name"] = 'ou'
    
            # Sounds a bit weird, but best found...
            elif diph == 'Oy_l': item["name"] = 'oey'
            elif diph == 'Oy_k': item["name"] = 'oey'
            elif diph == 'Oy_m': item["name"] = 'oey'
            elif diph == 'Oy_n': item["name"] = 'oey'
            elif diph == 'Oy_b': item["name"] = 'oey'
            elif diph == 'u_Oy':
                previous["name"] = 'oey'
                item["name"] = 'O:'
            elif diph == 't_Oy': previous["name"] = 'oey'
            elif diph == 'b_Oy': previous["name"] = 'oey'
            elif diph == 'h_Oy': previous["name"] = 'oey'
            elif diph == 'n_Oy': previous["name"] = 'oey'
    
            elif diph == 'i_y': previous["name"] = 'y:'
    
            elif diph == 'rL__ou:': item["name"] = 'rl'
    
            elif diph == 't_j': previous["name"] = 'i'
    
            elif diph == 'Ch_Ai':
                previous["name"] = 'aei'
                item["name"] = 'Sh'
    
            elif diph == 'eI_Z_': item["name"] = 'eh'
            elif diph == 'eh_h': item["name"] = 'e'
            elif diph == 'r_Ai' and 'air' == string.lower(str(word_orig["name"])[:3]): previous["name"] = 'e:'
            elif diph == 'u:_u': previous["name"] = 'u:'
            elif diph == 'u_rd': item["name"] = 'u:'
            elif diph == 'r__ae': item["name"] = 'r'
            elif diph == 'eh_O': item["name"] = 'e'
    
            elif diph[:3] == 'th_': item["name"] = 't'
        
            # Could be better... from /k @U/ to /k O: u/
            elif diph[:3] == '@U_':
                item["name"] = 'u'
                O_diph = EST_Item()
                O_diph["name"] = 'O:'
                O_diph_end = item["end"]
                O_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(O_diph_end) - 0.01)[:5])
                O_diph["end"] = O_diph_end
                previous = u2_seg.append(O_diph)
                append_daughter(O_diph_parent, "SylStructure", O_diph)
    
            elif diph[:3] == 'Ai_': # Could be better...
                item["name"] = 'i'
                A_diph = EST_Item()
                A_diph["name"] = 'A'
                A_diph_end = item["end"]
                A_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(A_diph_end) - 0.01)[:5])
                A_diph["end"] = A_diph_end
                previous = u2_seg.append(A_diph)
                append_daughter(A_diph_parent, "SylStructure", A_diph)
    
            elif diph[:3] == 'rt_': # Could be better...
                item["name"] = 't'
                r_diph = EST_Item()
                r_diph["name"] = 'r'
                r_diph_end = item["end"]
                r_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(r_diph_end) - 0.01)[:5])
                r_diph["end"] = r_diph_end
                previous = u2_seg.append(r_diph)
                append_daughter(r_diph_parent, "SylStructure", r_diph)
    
            elif diph[:3] == 'rd_': # Could be better...
                item["name"] = 'd'
                r_diph = EST_Item()
                r_diph["name"] = 'r'
                r_diph_end = item["end"]
                r_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(r_diph_end) - 0.01)[:5])
                r_diph["end"] = r_diph_end
                previous = u2_seg.append(r_diph)
                append_daughter(r_diph_parent, "SylStructure", r_diph)

            elif diph == 'u_u' and str(get_feature(word_orig, "name")) == str(get_feature(parent(parent(previous_orig, "SylStructure"), "SylStructure"), "name")):
                # Should do something here if the 'u_u' diphone is in the same word, e.g the word "wood"
                # Sets append_next to false, to avoid /u/ twice in a row.
                append_next = False

            elif diph == 'ae:_Ai': # Could be better...
                previous["name"] = 'A'
                item["name"] = 'aei'
                j_diph = EST_Item()
                j_diph["name"] = 'j'
                j_diph_end = item["end"]
                j_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(j_diph_end) - 0.01)[:5])
                j_diph["end"] = j_diph_end
                previous = u2_seg.append(j_diph)
                append_daughter(j_diph_parent, "SylStructure", j_diph)
    
            elif diph == 'sil_Z_': # Could be better...
                eh_diph = EST_Item()
                eh_diph["name"] = 'eh'
                eh_diph_end = item["end"]
                eh_diph_parent = parent(item, "SylStructure")
                previous["end"] = float(str(float(eh_diph_end) - 0.01)[:5])
                eh_diph["end"] = eh_diph_end
                previous = u2_seg.append(eh_diph)
                append_daughter(eh_diph_parent, "SylStructure", eh_diph)

            elif diph[-3:] == '_ae': previous["name"] = 'aei'
            elif 'ae_' in diph: item["name"] = 'aei'
            elif 'eI_' in diph: item["name"] = 'aei'

            # --> Norsk-engelsk :-)
            elif 'w_' in diph: item["name"] = 'v'
            elif '_r_' in diph: previous["name"] = 'r'
            elif 'r__' in diph: item["name"] = 'r'
    
            # Ikke god...
            elif 'aU_' in diph: item["name"] = 'aeu'
            elif 'D__' in diph: item["name"] = 'd'
            elif 'rl_' in diph: item["name"] = 'l'
            elif '_rL_' in diph and str(get_feature(word_orig, "name")) == str(get_feature(parent(parent(previous_orig, "SylStructure"), "SylStructure"), "name")): previous["name"] = 'l'
    
            elif 'sil_'+str(get_feature(previous, "name")) in diphones_list and str(get_feature(item, "name"))+'_sil' in diphones_list:
                sil = EST_Item()
                sil["name"] = 'sil'
                sil_end = float(str(float(previous["end"]) + 0.01)[:5])
                sil_parent = parent(item, "SylStructure")
                item["end"] = float(str(float(sil_end) + 0.01)[:5])
                sil["end"] = sil_end
                previous = u2_seg.append(sil)
                append_daughter(sil_parent, "SylStructure", sil)
            elif str(get_feature(next(item), "name"))+'_'+str(get_feature(previous, "name")) in diphones_list:
                #Legger ikke til item
                append_next = False
                remove = True
            elif str(get_feature(item, "name"))+'_'+str(get_feature(prev(previous), "name")) in diphones_list:
                #Legger ikke til previous (dvs endrer navn p previous til items navn, og legger ikke til item)
                append_next = False
                previous["name"] = item["name"]
                remove = True
            else:
                print ' Could not solve missing diphones by inserting /sil/ phonem between /' + str(get_feature(previous, "name")) + '/ and /' + str(get_feature(item, "name")) + '/ or other solutions.'
                unable = True
            diph = str(get_feature(item, "name")) + '_' + str(get_feature(previous, "name"))
            print 'endret til', diph,

            if silence:
                sil_score = sil_score + 1
            elif remove:
                remove_score = remove_score + 1
            elif unable:
                unable_score = unable_score + 1
            else:
                sub_score = sub_score + 1
        if append_next:
            previous = u2_seg.append(item)
        else:
            append_next = True
        previous_orig = item_orig
        print ''
    
    print ''
    
    # Saving the new utterance in a .utt file that can be loaded into Festival
    utt_id = utt_id + '.utt'
    u2.save(utt_id)
    if sil_score + sub_score + remove_score + unable_score == 0:
        utt_score[0] = utt_score[0] + 1
    else:
        utt_score[1] = utt_score[1] + sil_score
        utt_score[2] = utt_score[2] + sub_score
        utt_score[3] = utt_score[3] + remove_score
        utt_score[4] = utt_score[4] + unable_score

    sil_score = 0
    sub_score = 0
    remove_score = 0
    unable_score = 0

manuscript = None
utt_id = 'saved'
if sys.argv[1]:
    src = str(sys.argv[1])
    print src
    if src[-4:] == '.txt':
        manuscript = True
    elif src[-1] not in ['.', '!', '?']:
        src = src + '.'
else:
    print 'Ingen setning  syntetisere'
    src = '.'

if manuscript:
    src_file = open(src, 'r')
    for line in src_file.readlines():
        utt_id = line[1:9]
        src = str(line[11:-3])
        print utt_id, src
        synthezise(src, utt_id)
elif src != '.':
    synthezise(src, utt_id)

print utt_score
